<?php
/**
*	@version	0.2.2
*	@author		Ruud Eisinga (Ruud)
*	@date		2008-10-06
*	@state		@dev
*
*	Displays the number of hits per page.
*
*	Optional function for implantating inside a Template.
*
* 	Snippet: MiniCounter()
*	@param	integer	show/hide minicounter: 1 == show (default), 0 == hidden
*	@param	string	pagehits_str
*					The text in front of the total hits counter. (default := "Pagehits: ",
*					if set to "" no total counter is displayed)
*	@param	string	today_hits_str
*					The text in front of the today hits counter. (default := " (Today: ",
*					if set to "" no daily counter is displayed)
*	@param	string	closer_str
*					Optional text to close the result of the snippet. (default := ")",
*					if set to "" no closing is displayed)
*
	---------------------------------------------------------------------------------------------------------------
*
*	Snippet: Popular_pages()
*
*	@param	integer	diplayed_item_count
*					The amount of maximum displayed links.  (default: 5)
*	@param	string	header_text
*					The text above the list (default := "Most viewed pages:",
*	@param	integer	show_menu_title
*					Use the menu_title (normal behavour) for the generated links. If set to 0
					the Page Title will be used. (default = 1)
*	@param	integer	show_totals
*                                  	if set to 1 the "title" tooltip is filled with the amount of hits.
*					fixed text: "Total views: nnn"
*
*
*/

function MiniCounter($show_counter = 1, $hits = "Pagehits: ", $today = " (Today: ", $closer = ")", $admin_ip = "") {
	global $database;

	$useragent = $_SERVER['HTTP_USER_AGENT'];
	if (stristr($useragent,"ServerWatch")) return;

	$page = PAGE_ID;
	if ($page == 0) return;

	$item = subItem();
	
	$sqldate = date('Y-m-d');
	$counter = 0;
	$counter_total = 0;

	$table = TABLE_PREFIX ."mod_minicounter";
	$counter_res = $database->query("SELECT counter FROM " . $table . " WHERE page_id=".$page." AND item_id=".$item." AND date='".$sqldate."'" ); 
	if ($counter_res->numRows() > 0) {
		$counter_row = $counter_res->fetchRow();
		$counter = $counter_row['counter'];
	}
	if ($_SERVER['REMOTE_ADDR'] != $admin_ip) {  //Do not count admin ip address
		if (!isset($_SESSION['page_'.$page.'_'.$item]) || ($_SESSION['page_'.$page.'_'.$item] < time() - 300)) {
		$_SESSION['page_'.$page.'_'.$item] = time() ;
			if (!($counter)) {
				$sql = "INSERT INTO " . $table . " (page_id,item_id,date,counter) values (".$page.",".$item.",'".$sqldate."',1)";
				$counter = 1;
			} else 	{
				$counter++;
				$sql = "UPDATE " . $table . " set counter=".$counter." where page_id=".$page." AND item_id=".$item." AND date='".$sqldate."'";
			}
			$database->query($sql);
		}
	}
	$counter_res = $database->query("SELECT sum(counter) as counter FROM " . $table . " WHERE page_id=".$page." AND item_id=".$item);
	if ($counter_res && $counter_res->numRows() > 0) {
		$counter_row = $counter_res->fetchRow();
		$counter_total = $counter_row['counter'];
	} else
		$counter_total = 0;

	if (($show_counter == 1) || ($_SERVER['REMOTE_ADDR'] == $admin_ip)) {
		if ($hits)	echo $hits.$counter_total;
		if ($today)	echo $today.$counter;
		if ($closer)	echo $closer;
	}
}

function Popular_Pages($count = 5, $title = "Most viewed pages:", $show_menu_title = 1, $show_totals = 0) {
	global $database;
	$tbl_counter = TABLE_PREFIX ."mod_minicounter";
	$tbl_pages = TABLE_PREFIX ."pages";
	$pagelist = $database->query("SELECT sum(counter) as total, c.page_id, p.page_title, p.menu_title, p.link
		FROM $tbl_counter c
		INNER JOIN $tbl_pages p on (p.page_id = c.page_id)
		GROUP BY page_id
		ORDER BY total DESC");
	$inner_count = 0;
	if ($pagelist->numRows() > 0){
		echo "<div class=\"popularpages\"><h3>$title</h3></div><div class=\"popularlist\"><ul>";
		while(($res = $pagelist->fetchRow()) && ($inner_count++ < $count)) {
			echo "<li><a href=\"".page_link($res['link'])."\"";
			if ($show_totals) echo " title=\"Total views: ".$res['total']."\"";
			if ($show_menu_title == 1)
				echo ">".$res['menu_title']."</a></li>" ;
			else
				echo ">".$res['page_title']."</a></li>" ;

		}
		echo "</ul></div>";
	}
}


function subItem() {
	
	switch (true) {
		case defined('POST_ID'):	$retval = POST_ID; break;
		case defined('ITEM_ID'):	$retval = ITEM_ID; break;
		case defined('catalog_ID'):	$retval = catalog_ID; break;
		case defined('SONG_ID'):	$retval = SONG_ID; break;
		case defined('IMAGE_ID'):	$retval = IMAGE_ID; break;
		default:
			$retval = 0;
	}	
	return $retval;
}
?>
